[changes]
* API for a trigger added. The trigger can be used for example in email action of the scheduler.
* Formula functions "ToTextFixed" and "TranslateFixed" added.
* API improvement: adding a sub report to a sub report no longer leads to a corrupt engine but rather immediately throws an IllegalStateException.

#### Changed Behavior
* It is now possible to log in with a different user name if you are already logged in.
* The remote servlet now allows a redeploy and restart of the servlet without starting the whole server.
* The comparison of the subreport link values is now case-sensitive.
* Now the report data cache will be cleared each time you click on the refresh button.
* The using of column labels with MySQL connector 5.x and query commands works now by Engine.setData(ResultSet) and Engine.setSql(String).
* The mirroring of the report layout for RTL languages like Arabic respect also subreports and charts now.
* It's now allowed to create variables with the name of existing functions in a Crystal-syntax formula.
* Content rendered with text interpretation = 'HTML (advanced)' can now break within a word, in case the word is wider than the the field element width. This does not apply to text inside a HTML table or an auto-sized floated HTML element.
* The i-net Clear Reports startpage now only shows the red warning for deactivated features.
* It is now possible to execute the formula "{StringField}[startIndex to endIndex]" on a database. 

#### API Changes
* Added Classes
  * com.inet.report.Trigger
* Added Methods
  * Engine.getTrigger() 

### i-net Clear Reports viewer
* In the report viewer, if a report has been cancelled or is no longer valid, the navigation buttons are now disabled - before, it was possible to page through the invalid report with only white pages showing.

### i-net Designer
* Properties "Default Syntax for new Formulas" and "Default Null Behavior for new Formulas" added to the category "Extra" of the Designer Options. With these properties it is possible to set the default null behavior and the default syntax of the Formula Editor.
* Prompt descriptions now are no longer automatically interpreted as HTML, so that characters such as pointed brackets are now displayed correctly. Now, if you want to use HTML formatting for your prompt description, prefix your description with "&lt;html&gt;".
* Property "Suppress empty reports" added to the properties of a subreport.
* Various improvements and bug fixes made for the designer's prompt editor dialog.
* The Designer now supports repository URL's with redirects. 

#### Changed Behavior
* It is now possible to display the SQL statement of a command in the Database Wizard, even f the database conection is invalid.
* Formula Editor: The terms "{field} = null" and "{field} <> null" can now be used as null-checks as well.
* The summary dialog has been reworked.
* The designer now acceps a file path without –open as start parameter.
* The designer now creates its own special configuration called "Designer_Default" if the designer is started for the first time or the configuration the designer was based on has been deleted. This i-net Clear Reports configuration is pre-configured with various settings that make more sense for working on report design rather than for running an i-net Clear Reports server.

#### API Changes
* Removed Methods
  * AbstractDesignerDataModel.editElementsDialog(PropertyElementsHandle)
  * AbstractDesignerDataModel.editElementsDialog( PropertyElementsHandle, PropertyEditor)
  * AbstractDesignerDataModel.openPropertiesDialog(PropertyElementsHandle)
  * DesignerDataModel.openPropertiesDialog(PropertyElementsHandle)

### Configuration Manager
* Property "Servlet Filter" added.
* The scope USER_SESSION was added for datasources. 

### Repository
* Remote Repository Browser now updates the folders and files on browser refresh.

### Scheduler
* The scheduler now use the logging of i-net Clear Reports. 

### Setup
* During installation, ::1 and 127.0.0.1 are now both shown in the IP filter list by default, so that users will not lock localhost out of the server if their system uses IPv6 for example.
* Even for a package installation, the ReportReader files are copied into the installation directory.

### .Net Edition
* i-net Clear Reports .NET: One of the shortcuts in the Windows start menu was incorrectly generated and was invalid.

[changes:de]
* API für einen Auslöser hinzugefügt. Der Trigger kann z.B. in der E-Mail-Aktion des Schedulers verwendet werden.
* Formel-Funktionen "ToTextFixed" und "TranslateFixed" hinzugefügt.
* API-Verbesserung: Das Hinzufügen eines Unterberichts zu einem Unterbericht führt nicht mehr zu einer fehlerhaften Engine, sondern löst sofort eine IllegalStateException aus.

#### Geändertes Verhalten
* Es ist jetzt möglich, sich mit einem anderen Benutzernamen anzumelden, wenn man bereits angemeldet ist.
* Das Remote-Servlet erlaubt nun eine Neuverteilung und einen Neustart des Servlets, ohne den gesamten Server zu starten.
* Beim Vergleich der Subreport-Link-Werte wird jetzt zwischen Groß- und Kleinschreibung unterschieden.
* Der Cache der Berichtsdaten wird jetzt jedes Mal geleert, wenn Sie auf die Schaltfläche Aktualisieren klicken.
* Die Verwendung von Spaltenbeschriftungen mit dem MySQL-Konnektor 5.x und Abfragebefehlen funktioniert jetzt durch Engine.setData(ResultSet) und Engine.setSql(String).
* Die Spiegelung des Report-Layouts für RTL-Sprachen wie Arabisch berücksichtigt nun auch Subreports und Charts.
* Es ist nun möglich, Variablen mit dem Namen von bestehenden Funktionen in einer Crystal-Syntax-Formel zu erstellen.
* Inhalte, die mit Textinterpretation = 'HTML (advanced)' gerendert werden, können nun innerhalb eines Wortes umbrechen, wenn das Wort breiter ist als die Breite des Feldelements. Dies gilt nicht für Text innerhalb einer HTML-Tabelle oder eines HTML-Elements mit automatischer Größenanpassung.
* Auf der Startseite von i-net Clear Reports wird jetzt nur noch die rote Warnung für deaktivierte Funktionen angezeigt.
* Es ist jetzt möglich, die Formel "{StringField}[startIndex bis endIndex]" auf einer Datenbank auszuführen.

#### API-Änderungen
* Klassen hinzugefügt
  * com.inet.report.Trigger
* Hinzugefügte Methoden
  * Engine.getTrigger()

### i-net Clear Reports Viewer
* Wenn ein Bericht abgebrochen wurde oder nicht mehr gültig ist, sind die Navigationsschaltflächen im Berichtsbetrachter nun deaktiviert - zuvor war es möglich, durch den ungültigen Bericht zu blättern, wobei nur weiße Seiten angezeigt wurden.

### i-net Designer
* Eigenschaften "Standard-Syntax für neue Formeln" und "Standard-Null-Verhalten für neue Formeln" zur Kategorie "Extra" der Designer-Optionen hinzugefügt. Mit diesen Eigenschaften ist es möglich, das Standard-Nullverhalten und die Standardsyntax des Formeleditors einzustellen.
* Prompt-Beschreibungen werden nun nicht mehr automatisch als HTML interpretiert, so dass Zeichen wie spitze Klammern nun korrekt angezeigt werden. Wenn Sie die HTML-Formatierung für Ihre Prompt-Beschreibung verwenden möchten, stellen Sie Ihrer Beschreibung jetzt "&lt;html&gt;" voran.
* Eigenschaft "Leere Berichte unterdrücken" zu den Eigenschaften eines Unterberichts hinzugefügt.
* Verschiedene Verbesserungen und Fehlerkorrekturen für den Prompt-Editor-Dialog des Designers vorgenommen.
* Der Designer unterstützt jetzt Repository-URLs mit Weiterleitungen.

#### Geändertes Verhalten
* Es ist jetzt möglich, die SQL-Anweisung eines Befehls im Datenbank-Assistenten anzuzeigen, auch wenn die Datenbankverbindung ungültig ist.
* Formel-Editor: Die Begriffe "{field} = null" und "{field} <> null" können nun auch als Null-Checks verwendet werden.
* Der Zusammenfassungsdialog wurde überarbeitet.
* Der Designer akzeptiert jetzt auch einen Dateipfad ohne -open als Startparameter.
* Der Designer erstellt nun eine eigene Konfiguration namens "Designer_Default", wenn der Designer zum ersten Mal gestartet wird oder die Konfiguration, auf der der Designer basierte, gelöscht wurde. Diese i-net Clear Reports-Konfiguration ist mit verschiedenen Einstellungen vorkonfiguriert, die eher für die Arbeit am Berichtsdesign als für den Betrieb eines i-net Clear Reports-Servers sinnvoll sind.

#### API-Änderungen
* Entfernte Methoden
  * AbstractDesignerDataModel.editElementsDialog(PropertyElementsHandle)
  * AbstractDesignerDataModel.editElementsDialog( PropertyElementsHandle, PropertyEditor)
  * AbstractDesignerDataModel.openPropertiesDialog(PropertyElementsHandle)
  * DesignerDataModel.openPropertiesDialog(PropertyElementsHandle)

### Konfigurations-Manager
* Eigenschaft "Servlet Filter" hinzugefügt.
* Der Bereich USER_SESSION wurde für Datenquellen hinzugefügt.

### Repository
* Remote Repository Browser aktualisiert nun die Ordner und Dateien beim Aktualisieren des Browsers.

### Scheduler
* Der Scheduler verwendet nun die Protokollierung von i-net Clear Reports.

### Einrichtung
* Bei der Installation werden nun standardmäßig ::1 und 127.0.0.1 in der IP-Filterliste angezeigt, so dass Benutzer localhost nicht vom Server aussperren, wenn ihr System z.B. IPv6 verwendet.
* Auch bei einer Paketinstallation werden die ReportReader-Dateien in das Installationsverzeichnis kopiert.

### .Net Edition
* i-net Clear Reports .NET: Eine der Verknüpfungen im Windows-Startmenü wurde falsch generiert und war ungültig.

[bugfixes]
* In rare cases, when saving older reports with SQL Expression Fields, the fields were incorrectly saved, making them invalid.
* In rare cases, older reports had issues with SQL Expression Fields which led to them being loaded in the latest version of i-net Clear Reports as having the name "null". This caused the report to no longer work.
* Prompt names including "&lt;/script&gt;" in the name could cause issues in the HTML-based Prompt Dialog. The names are now correctly escaped.
* An IllegalArgumentException occurred if a continuous chart was drawn with multiple null values.
* A login request (HTTP code 401) need a long time with JBoss because the wrong content length was send to the client.
* Report Reader:
  * In some cases when reading a Crystal Reports template, lines were read as being below the boxes, however this is not possible in Crystal Reports. Now, the boxes are always placed below any line elements in the section, according to how Crystal Reports works.
  * When reading Crystal Reports templates, summary fields with a "reset on group" setting were incorrectly read as resetting on the field the group was based on rather than on the group itself.
  * The group option "evaluate on change of field" was incorrectly read from Crystal Reports templates by the Report Reader.
  * When reading a report using the Report Reader on systems with Crystal Reports 2008 SP3 or higher, an API change introduced in the SP3 update caused the error "Object reference not set to an instance of an object" for certain summary fields.
* The 'case sensitivity' parameter was ignored, if the formula function InStr was executed on database.
* A section was as blank (empty) detected, if it contains only a JavaBean on top of this section (Top = 0).
* Fixed a security bug which allowed a user to be partly authenticated in the system when another user opened the remote designer.
* Formulas could not store any and all characters, even ones normally invalid in XML documents.
* Special fields with numbers (such as Page Number and others) lost any custom number format settings when the report was saved and re-loaded.
* The XML RPC method "listResources" returned an error if any of the resource names used multi-byte characters.
* Special field "Page N of M" was not displayed correctly in PDF export, if the font SansSerif was used.
* Field references in the field browser tree were incorrectly counted when they were referenced by parameter default value formulas and then undoing multiple steps of report design.
* PDF export: 
  * The length of underline in rich HTML hyperlinks was incorrect.
  * Some patterns were not shown after the first page.
* HTML export: The first paragraph was not shown, if it was empty. 
* Text interpretation "HTML(Advanced)" now relies on the actual fonts used by any renderer(e.g. PDF or XLS) which provides a more accurate render output for fonts not known to the Java font system.
* Shutting down then restarting an i-net Clear Reports server caused the logging to be deactivated the second time around.
* The data of the report was emtpy if the report was executed three times by using of report data cache.
* Non JDBC Database classes has not worked, if the data source configuration of the report does not exists on the server. In this case it has tried to connect to a JDBC connection.

### i-net Clear Reports viewer
* Changing tabs in the Safari browser to a different tab than the report viewer applet caused the report currently being displayed in the applet to no longer be visible, even after switching back to the viewer. Now, tab changes work without problems even for browsers such as Safari.
* Workaround for a bug in the Java VM added. Because of the bug it could occur that the end of long text lines were cut on printing. The clipping depends on the text, font, font size and it occurs very rarely.
* Selecting search results in the viewer sometimes did not highlight the result in the viewer panel when a result was on a page not currently being displayed.
* Font auto scaling in the java viewer for text generated by an HTML(Advanced) text field was wrong.

### i-net Designer
* The fields browser tree of the subreport was displayed instead of the fields browser of the main report when opening the dialog "Subreport Links" from the context menu of the subreport prompt fields.
* In the designer, re-running a report in the preview tab caused the error bar to display "Loading error" for a split second each time.
* The tooltip for warnings from the problem finder now appears below the warning.
* A special field of type number don't respect the "decimals" properties defined in the default values for number field elements anymore.
* The tutorial "How to create a datasource" has not worked on Macs OSX.
* In a German locale, the designer's prompt dialog interpreted string limit lengths incorrectly.
* Sometime the selected file could not be opened in the designer filechooser due to a deactivated open button.
* The context menu for links in the Database Wizard was not visible, if i-net Designer runs on Mac OS X.
* Opening a subreport doesn't behave like a change to the report anymore. An undo step will be created but save is not enabled if no other changes took place.
* In the designer, if a database connection was encountering a timeout and the preview process was canceled by pressing escape, the process loader could cause the designer to hang for 20-30 seconds before displaying an error.
* In the designer, if a report contained an incorrect database password, the password dialog was not displayed to correct the password when trying to preview the report.
* If a new report is saved and then changes are undone and the report is re-saved, the designer would incorrectly warn the user that the report had an old format.

### Configuration Manager
* It was not possible to add more than 17 users and/or groups to the System Permissions.
* The i-net Clear Reports configuration was unable to store very lengthy values in the Preferences. This had the effect that it was not possible to administer system permission rights to more than 15-20 users. This has been fixed, values can now have arbitrary length and as many users as desired can be created and administered in the i-net Clear Reports configuration manager. 

### Remote Interface
* The Remote Interface did not work with Internet Explorer 9.
* When scanning new drivers in the web-based data source manager, the new drivers were displayed in the list, but could not be selected until leaving and re-entering the menu.

[bugfixes:de]
* In seltenen Fällen wurden beim Speichern älterer Berichte mit SQL-Ausdruckfeldern die Felder nicht korrekt gespeichert, wodurch sie ungültig wurden.
* In seltenen Fällen gab es bei älteren Berichten mit SQL-Ausdruckfeldern Probleme, die dazu führten, dass sie in der neuesten Version von i-net Clear Reports mit dem Namen "null" geladen wurden. Dies führte dazu, dass der Bericht nicht mehr funktionierte.
* Prompt-Namen, die "&lt;/script&gt;" im Namen enthielten, konnten im HTML-basierten Prompt-Dialog Probleme verursachen. Die Namen werden nun korrekt escaped.
* Eine IllegalArgumentException trat auf, wenn ein kontinuierliches Diagramm mit mehreren Nullwerten gezeichnet wurde.
* Eine Login-Anfrage (HTTP-Code 401) brauchte bei JBoss sehr lange, weil die falsche Inhaltslänge an den Client gesendet wurde.
* Berichtsleser:
  * In einigen Fällen wurden beim Lesen einer Crystal-Reports-Vorlage die Zeilen so gelesen, als befänden sie sich unterhalb der Boxen, was in Crystal Reports jedoch nicht möglich ist. Jetzt werden die Boxen immer unter allen Zeilenelementen im Abschnitt platziert, so wie es in Crystal Reports funktioniert.
  * Beim Lesen von Crystal Reports-Vorlagen wurden Statistikfelder mit der Einstellung "Zurücksetzen bei Gruppe" fälschlicherweise so gelesen, dass sie bei dem Feld zurückgesetzt wurden, auf dem die Gruppe basierte, und nicht bei der Gruppe selbst.
  * Die Gruppenoption "Auswerten bei Feldänderung" wurde vom Report Reader fälschlicherweise aus Crystal Reports-Vorlagen ausgelesen.
  * Beim Lesen eines Berichts mit dem Report Reader auf Systemen mit Crystal Reports 2008 SP3 oder höher verursachte eine mit dem SP3-Update eingeführte API-Änderung für bestimmte Statistikfelder den Fehler "Objektreferenz nicht auf eine Instanz eines Objekts gesetzt".
* Der Parameter "Groß-/Kleinschreibung" wurde ignoriert, wenn die Formelfunktion InStr auf der Datenbank ausgeführt wurde.
* Ein Abschnitt wurde als leer (leer) erkannt, wenn er nur eine JavaBean über diesem Abschnitt enthält (Top = 0).
* Es wurde ein Sicherheitsproblem behoben, durch das ein Benutzer teilweise im System authentifiziert werden konnte, wenn ein anderer Benutzer den Remote-Designer öffnete.
* Formeln konnten nicht alle Zeichen speichern, auch solche, die normalerweise in XML-Dokumenten ungültig sind.
* Spezielle Felder mit Zahlen (wie Seitenzahl und andere) verloren alle benutzerdefinierten Zahlenformateinstellungen, wenn der Bericht gespeichert und erneut geladen wurde.
* Die XML-RPC-Methode "listResources" gab einen Fehler zurück, wenn einer der Ressourcennamen Multi-Byte-Zeichen enthielt.
* Das Spezialfeld "Seite N von M" wurde im PDF-Export nicht korrekt angezeigt, wenn die Schriftart SansSerif verwendet wurde.
* Feldreferenzen im Feldbrowser-Baum wurden falsch gezählt, wenn sie von Parameter-Standardwertformeln referenziert wurden und dann mehrere Schritte der Berichtsgestaltung rückgängig gemacht wurden.
* PDF-Export:
  * Die Länge der Unterstreichung in Rich-HTML-Hyperlinks war nicht korrekt.
  * Einige Muster wurden nach der ersten Seite nicht mehr angezeigt.
* HTML-Export: Der erste Absatz wurde nicht angezeigt, wenn er leer war.
* Die Textinterpretation "HTML(Advanced)" stützt sich jetzt auf die von einem Renderer (z. B. PDF oder XLS) verwendeten Schriftarten, was eine genauere Rendering-Ausgabe für Schriftarten ermöglicht, die dem Java-Schriftsystem nicht bekannt sind.
* Das Herunterfahren und erneute Starten eines i-net Clear Reports-Servers führte dazu, dass die Protokollierung beim zweiten Mal deaktiviert wurde.
* Die Daten des Berichts wurden emtpy, wenn der Bericht dreimal ausgeführt wurde, indem der Berichtsdaten-Cache verwendet wurde.
* Nicht JDBC-Datenbankklassen haben nicht funktioniert, wenn die Datenquellenkonfiguration des Berichts nicht auf dem Server existiert. In diesem Fall wurde versucht, eine Verbindung zu einer JDBC-Verbindung herzustellen.

### i-net Clear Reports Viewer
* Das Wechseln von Tabs im Safari-Browser auf einen anderen Tab als das Report-Viewer-Applet führte dazu, dass der gerade im Applet angezeigte Report nicht mehr sichtbar war, auch wenn man zurück zum Viewer wechselte. Jetzt funktioniert der Tab-Wechsel auch bei Browsern wie Safari problemlos.
* Workaround für einen Fehler in der Java VM hinzugefügt. Durch den Fehler konnte es vorkommen, dass das Ende von langen Textzeilen beim Drucken abgeschnitten wurde. Das Abschneiden hängt vom Text, der Schriftart und der Schriftgröße ab und tritt sehr selten auf.
* Beim Auswählen von Suchergebnissen im Viewer wurde das Ergebnis im Viewer-Panel manchmal nicht hervorgehoben, wenn sich ein Ergebnis auf einer Seite befand, die gerade nicht angezeigt wurde.
* Die automatische Skalierung der Schriftart im Java-Viewer für Text, der von einem HTML(Advanced)-Textfeld erzeugt wurde, war falsch.

### i-net Designer
* Der Feldbrowser-Baum des Unterberichts wurde anstelle des Feldbrowsers des Hauptberichts angezeigt, wenn der Dialog "Unterberichtsverknüpfungen" über das Kontextmenü der Eingabeaufforderungsfelder des Unterberichts geöffnet wurde.
* Im Designer führte das erneute Ausführen eines Berichts in der Vorschau-Registerkarte dazu, dass die Fehlerleiste jedes Mal für einen Sekundenbruchteil "Ladefehler" anzeigte.
* Der Tooltip für Warnungen aus dem Problemfinder erscheint nun unterhalb der Warnung.
* Ein spezielles Feld vom Typ Zahl beachtet nicht mehr die "Dezimal"-Eigenschaften, die in den Standardwerten für Zahlenfeldelemente definiert sind.
* Das Tutorial "Wie man eine Datenquelle erstellt" hat auf Macs OSX nicht funktioniert.
* In einem deutschen Gebietsschema interpretierte der Eingabeaufforderungsdialog des Designers die Grenzlängen von Strings falsch.
* Manchmal konnte die ausgewählte Datei im Dateiauswahldialog des Designers nicht geöffnet werden, weil die Schaltfläche "Öffnen" deaktiviert war.
* Das Kontextmenü für Links im Datenbank-Assistenten war nicht sichtbar, wenn der i-net Designer unter Mac OS X läuft.
* Das Öffnen eines Unterberichts verhält sich nicht mehr wie eine Änderung des Berichts. Es wird ein Rückgängig-Schritt erzeugt, aber das Speichern ist nicht möglich, wenn keine anderen Änderungen vorgenommen wurden.
* Wenn im Designer eine Datenbankverbindung eine Zeitüberschreitung erfuhr und der Vorschauprozess durch Drücken der Escape-Taste abgebrochen wurde, konnte der Prozesslader dazu führen, dass der Designer für 20-30 Sekunden hängen blieb, bevor er einen Fehler anzeigte.
* Wenn ein Bericht im Designer ein falsches Datenbankpasswort enthielt, wurde der Passwortdialog nicht angezeigt, um das Passwort zu korrigieren, wenn versucht wurde, eine Vorschau des Berichts zu erstellen.
* Wenn ein neuer Bericht gespeichert wird und dann die Änderungen rückgängig gemacht werden und der Bericht erneut gespeichert wird, warnte der Designer den Benutzer fälschlicherweise, dass der Bericht ein altes Format hat.

### Konfigurations-Manager
* Es war nicht möglich, mehr als 17 Benutzer und/oder Gruppen zu den Systemberechtigungen hinzuzufügen.
* Die i-net Clear Reports Konfiguration war nicht in der Lage, sehr lange Werte in den Voreinstellungen zu speichern. Dies hatte zur Folge, dass es nicht möglich war, Systemberechtigungen für mehr als 15-20 Benutzer zu verwalten. Dies wurde nun behoben, die Werte können nun beliebig lang sein und es können beliebig viele Benutzer im i-net Clear Reports Konfigurationsmanager angelegt und verwaltet werden.

### Remote Interface
* Das Remote Interface funktionierte nicht mit dem Internet Explorer 9.
* Beim Scannen neuer Treiber im webbasierten Datenquellenmanager wurden die neuen Treiber zwar in der Liste angezeigt, konnten aber erst nach Verlassen und erneutem Aufruf des Menüs ausgewählt werden.

[security]

[security:de]
